package mv3302.run;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.List;
import mv3302.SimpleCookieCutterMediator;
import mv3302.SimpleMover;
import mv3302.SimplePatrolMoverManager;
import mv3302.SimpleReferee;
import mv3302.sensor.AbstractSimpleSensor;
import mv3302.sensor.SimpleCookieCutterSensor;
import simkit.Schedule;
import simkit.animate.SandboxFrame;
import simkit.smd.Mover;
import simkit.smd.Sensor;
import simkit.util.PropertyChangeFrame;

/**
 *
 * @author ahbuss
 */
public class TestAnimations {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        SimpleMover mover1 = new SimpleMover(new Point2D.Double(-20.0, 0.0), 30.0);
        AbstractSimpleSensor sensor1 = new SimpleCookieCutterSensor(mover1, 20.0);
        Point2D[] moverPath1 = new Point2D[]{
            new Point2D.Double(100.0, 0.0),
            mover1.getInitialLocation()
        };
        SimplePatrolMoverManager moverManager1 = new SimplePatrolMoverManager(moverPath1, true);
        
        mover1.addSimEventListener(moverManager1);
        moverManager1.addSimEventListener(mover1);
        
        SimpleMover mover2 = new SimpleMover(new Point2D.Double(50.0, 0.0), 40.0);
        AbstractSimpleSensor sensor2 = new SimpleCookieCutterSensor(mover2, 30.0);
        Point2D[] moverPath2 = new Point2D[] {
            new Point2D.Double(-100.0, 0.0),
            mover2.getInitialLocation()
        };
        SimplePatrolMoverManager moverManager2 = new SimplePatrolMoverManager(moverPath2, true);
        mover2.addSimEventListener(moverManager2);
        moverManager2.addSimEventListener(mover2);

//        PropertyChangeListener propertyChangeFrame = new SimplePropertyDumper(true);
        PropertyChangeFrame propertyChangeFrame = new PropertyChangeFrame();
//        mover1.addPropertyChangeListener(propertyChangeFrame);
//        moverManager1.addPropertyChangeListener(propertyChangeFrame);
        sensor1.addPropertyChangeListener("detection", propertyChangeFrame);
        sensor1.addPropertyChangeListener("undetection", propertyChangeFrame);
        
//        mover2.addPropertyChangeListener(propertyChangeFrame);
//        moverManager2.addPropertyChangeListener(propertyChangeFrame);
        sensor2.addPropertyChangeListener("detection", propertyChangeFrame);
        sensor2.addPropertyChangeListener("undetection", propertyChangeFrame);
//        
        List<Mover> targets = new ArrayList<>();
        targets.add(mover1);
        targets.add(mover2);
        
        List<Sensor> sensors = new ArrayList<>();
        sensors.add(sensor1);
        sensors.add(sensor2);
        
        SimpleReferee referee = new SimpleReferee(sensors, targets);
        
        SimpleCookieCutterMediator mediator1 = new SimpleCookieCutterMediator();
        referee.addSimEventListener(mediator1);
        
        System.out.println(mover1.paramString());
        System.out.println(moverManager1);
        System.out.println(sensor1.paramString());
        
        System.out.println(mover2.paramString());
        System.out.println(moverManager2);
        System.out.println(sensor2.paramString());
        
        System.out.println(referee);
        
        Schedule.setVerbose(false);
        
//        Schedule.stopOnEvent(5, "Detection", SimpleMover.class);
        
        
        SandboxFrame sandboxFrame = new SandboxFrame("Simple Referee");
        sandboxFrame.getSandbox().setOrigin(new Point2D.Double(200, 200));
        sandboxFrame.getSandbox().setDrawAxes(true);
        
        sandboxFrame.addMover(mover1, Color.BLUE);
        sandboxFrame.addSensor(sensor1, Color.RED);
        sandboxFrame.addMover(mover2, Color.GREEN);
        sandboxFrame.addSensor(sensor2, Color.ORANGE);
        
        sandboxFrame.setVisible(true);
        
        propertyChangeFrame.setLocation(sandboxFrame.getX() + sandboxFrame.getWidth(), sandboxFrame.getY());
        propertyChangeFrame.setVisible(true);
        Schedule.reset();
        
        Schedule.addIgnoreOnDump("Ping");

//        Schedule.startSimulation();
        
    }
    
}
